package com.gic.haoban.manage.service.service.out.impl;


import cn.hutool.core.collection.CollectionUtil;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.gic.haoban.manage.api.dto.*;
import com.gic.haoban.manage.api.enums.SecretTypeEnum;
import com.gic.haoban.manage.service.service.*;
import com.gic.wechat.api.dto.qywx.QywxIinkExternalMessageDTO;
import com.gic.wechat.api.dto.qywx.QywxImageExternalMessageDTO;
import com.gic.wechat.api.dto.qywx.QywxTextExternalMessageDTO;
import com.gic.wechat.api.service.qywx.QywxSuiteApiService;
import com.gic.wechat.api.service.qywx.QywxUserApiService;
import com.github.pagehelper.PageHelper;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

import org.apache.commons.lang3.StringUtils;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.gic.api.base.commons.JSONResponse;
import com.gic.api.base.commons.Page;
import com.gic.clerk.api.dto.ClerkDTO;
import com.gic.clerk.api.service.ClerkService;
import com.gic.commons.util.DateUtil;
import com.gic.commons.util.EntityUtil;
import com.gic.commons.util.MD5Utils;
import com.gic.commons.util.Md5Util;
import com.gic.commons.util.StringUtil;
import com.gic.enterprise.api.dto.StoreDTO;
import com.gic.enterprise.api.service.StoreService;
import com.gic.haoban.base.api.common.BasePageInfo;
import com.gic.haoban.common.utils.PageUtil;
import com.gic.haoban.contacts.manage.api.dto.SearchDataDTO;
import com.gic.haoban.manage.api.service.DepartmentApiService;
import com.gic.haoban.manage.api.service.MaterialApiService;
import com.gic.haoban.manage.api.service.MemberUnionidRelatedApiService;
import com.gic.haoban.manage.api.service.StaffDepartmentRelatedApiService;
import com.gic.haoban.manage.api.service.WxEnterpriseApiService;
import com.gic.haoban.manage.service.config.Config;
import com.gic.haoban.manage.service.dao.mapper.MemberUnionidRelatedMapper;
import com.gic.haoban.manage.service.entity.MemberUnionidRelated;
import com.gic.haoban.manage.service.entity.TabHaobanClerkMainStoreRelated;
import com.gic.haoban.manage.service.entity.TabHaobanExternalClerkRelated;
import com.gic.haoban.manage.service.entity.TabHaobanStaff;
import com.gic.haoban.manage.service.entity.TabHaobanStaffDepartmentRelated;
import com.gic.haoban.manage.service.entity.TabHaobanWxEnterprise;
import com.gic.haoban.manage.service.entity.TabHaobanWxEnterpriseRelated;
import com.gic.haoban.manage.service.pojo.ExternalUserPojo;
import com.gic.haoban.manage.service.util.EmojiFilterUtil;
import com.gic.member.api.dto.MemberDTO;
import com.gic.member.api.service.MemberOpenCardBusinessService;
import com.gic.member.api.service.MemberService;
import com.gic.redis.data.anno.RedisLock;
import com.gic.redis.data.util.RedisUtil;
import com.gic.search.engine.api.constant.MemberDataEnum;
import com.gic.search.engine.api.constant.OperateEnum;
import com.gic.search.engine.api.dto.ESResponseQueryBatch;
import com.gic.search.engine.api.dto.ESResponseQuerySingle;
import com.gic.search.engine.api.dto.dynamic.DynamicSearchDTO;
import com.gic.search.engine.api.filter.NewNodeAddUtil;
import com.gic.search.engine.api.service.dynamic.ESDataDynamicOperationApiService;

@Service
public class MemberUnionidRelatedApiServiceImpl implements MemberUnionidRelatedApiService{
	private static final Logger log = LogManager.getLogger(MemberUnionidRelatedApiServiceImpl.class);
	@Autowired
	private MemberUnionRelatedService memberUnionRelatedService;
	@Autowired
	private StaffService staffService;
	@Autowired
	private QywxUserApiService qywxUserApiService;
	@Autowired
	private com.gic.enterprise.api.service.StoreGroupService gicDepartmentService;
	@Autowired
	private MemberService memberService;
	@Autowired
	private WxEnterpriseRelatedService wxEnterpriseRelatedService;
	@Autowired
	private WxEnterpriseService wxEnterpriseService;
	
	private static final String SELF_APP = "selfSuiteId";
	
	@Autowired
	private MemberOpenCardBusinessService memberOpenCardBusinessService;
	
	@Autowired
	private ClerkService clerkService;
	@Autowired
	private DepartmentApiService departmentApiService;

	@Autowired
	private MemberUnionidRelatedMapper memberUnionidRelatedMapper;
	
	@Autowired
	private StaffDepartmentRelatedService staffDepartmentRelatedService;
	@Autowired
	private ESDataDynamicOperationApiService eSDataDynamicOperationApiService;
	@Autowired
	private ClerkMainStoreRelatedService clerkMainStoreRelatedService;
	@Autowired
	private StoreService storeService;
	@Autowired
	private Config config;
	@Autowired
	private QywxSuiteApiService qywxSuiteApiService;
	@Autowired
	private MaterialApiService materialApiService;

	@Autowired
	private SecretSettingService secretSettingService;
	
	@Autowired
	private StaffClerkRelationService staffClerkRelationService;
	@Autowired
	private ExternalClerkRelatedService externalClerkRelatedService;
	
	@Override
	public List<MemberStoreDTO> listByExTernalUseridAndWxUserId(String externalUserid, String wxUserId) {
		List<TabHaobanExternalClerkRelated> list = externalClerkRelatedService.listByExTernalUseridAndWxUserId(externalUserid, wxUserId);
		List<MemberStoreDTO> result = new ArrayList<>();
		if(CollectionUtil.isEmpty(list)){
			return null;
		}
		String wxEnterpriseId = list.get(0).getWxEnterpriseId();
		TabHaobanStaff haobanStaff = staffService.selectByUserIdAndEnterpriseId(wxUserId, wxEnterpriseId);
		if (null == haobanStaff) {
			log.info("staff不存在");
			return null;
		}
		List<StaffClerkRelationDTO> clerkRelationDTOS = staffClerkRelationService.listBindCodeByStaffId(null, haobanStaff.getStaffId());
		if(CollectionUtil.isEmpty(clerkRelationDTOS)){
			log.info("staff关联门店不存在1");
			return null;
		}
//		//1、查该staff的门店id
//		List<TabHaobanStaffDepartmentRelated> relatedIds = staffDepartmentRelatedService.listByWxUserId(wxUserId);
//		if(CollectionUtil.isEmpty(relatedIds)){
//			log.info("staff关联部门不存在1");
//			return null;
//		}
//		List<String> departmentIds = relatedIds.stream().map(s->s.getDepartmentId()).collect(Collectors.toList());
//		if(CollectionUtil.isEmpty(departmentIds)){
//			log.info("staff部门不存在1");
//			return null;
//		}
//		List<DepartmentDTO> stores  = departmentApiService.listByDepartmentIds(departmentIds, 1);
//		if(CollectionUtil.isEmpty(stores)){
//			log.info("staff关联门店不存在1");
//			return null;
//		}
		List<String> storeIds = clerkRelationDTOS.stream().filter(s->(s.getStoreId()!=null || "".equals(s.getStoreId()))).map(s->s.getStoreId()).collect(Collectors.toList());
		if(CollectionUtil.isEmpty(storeIds)){
			log.info("staff关联门店不存在2");
			return null;
		}
		//2、获取member的storeId
		for(TabHaobanExternalClerkRelated tab : list){
			String memberId = tab.getMemberId();
			if(StringUtils.isEmpty(memberId)){
				continue ;
			}
			String gicEnterpriseId = tab.getEnterpriseId();
			JSONObject searchJson = new JSONObject();
			searchJson = NewNodeAddUtil.addNewNodeForAnd(MemberDataEnum.member_memberId.getCode(), OperateEnum.OPERATE_EQ.getValue(), memberId,searchJson);
			DynamicSearchDTO dynamicSearchDTO = new DynamicSearchDTO();
			dynamicSearchDTO.setEnterpriseId(gicEnterpriseId);
			dynamicSearchDTO.setColumnCategoryCode("member");
			dynamicSearchDTO.setSearchJson(searchJson);
			dynamicSearchDTO.setBegin(0);
			dynamicSearchDTO.setRecordNumber(1);
			log.info("gicEnterpriseId=========>{},searchJson=========={}",gicEnterpriseId,searchJson);
			ESResponseQueryBatch responseQuery = eSDataDynamicOperationApiService.queryDataBatch(dynamicSearchDTO, false, null);
			if(null == responseQuery){
				log.info("会员不存在1");
				continue;
			}
			List<JSONObject> res = responseQuery.getRes();			
			if(CollectionUtil.isEmpty(res)){
				log.info("会员不存在2");
				continue;
			}
			String storeId = "";
			for (JSONObject jsonObject : res) {
				 storeId = jsonObject.get("storeId") == null?"":jsonObject.get("storeId").toString();
			}
			if(StringUtils.isEmpty(storeId)){
				log.info("会员门店不存在");
				continue;
			}
			String[] memberStoreIds =storeId.split(" "); 
			List<String> memberStoreIdList = Arrays.asList(memberStoreIds);
			if(CollectionUtil.isEmpty(memberStoreIdList)){
				log.info("会员门店不存在");
				continue;
			}
			log.info("memberStoreIdList===============>{}",JSONObject.toJSONString(memberStoreIdList));
			log.info("storeIds===============>{}",JSONObject.toJSONString(storeIds));
			//取交集(解决不支持的报错现象)
			List list3= new ArrayList(memberStoreIdList);
			List list4= new ArrayList(storeIds);
			list3.retainAll(list4);
			if(CollectionUtil.isEmpty(list3)){
				continue;
			}else{
				for(Object resultStoreId : list3){
					MemberStoreDTO dto = new MemberStoreDTO();
					dto.setMemberId(memberId);
					dto.setStoreId(resultStoreId.toString());
					result.add(dto);
				}
				
			}
		}
		return result;
	}
	@Override
	public MemberUnionidRelatedDTO getByUnionId(String staffId, String unionid) {
		TabHaobanStaff staff = staffService.selectById(staffId);
		if(staff == null){
			return null;
		}
		log.info("【查询会员】wxUserId={},unionid={}",staff.getWxUserId(),unionid);
		return memberUnionRelatedService.getByUnionId(staff.getWxUserId(),unionid);
	}
	@Override
	public String addMemberUnionidRelated(MemberUnionidRelatedDTO dto) {
		return addMemberUnionidRelatedNew(dto);
	}
	
	
	@Override
	public String addMemberUnionidRelatedNew(MemberUnionidRelatedDTO dto) {
		log.info("【新增外部联系人回调】dto={}",JSON.toJSONString(dto));
		String corpId = dto.getCorpid();
		TabHaobanWxEnterprise wxEnterprise = wxEnterpriseService.getEnterpriseBycorpId(corpId);
		if(wxEnterprise == null){
			return "";
		}
		
		String wxEnterpriseId = wxEnterprise.getWxEnterpriseId();
		
		String userId = dto.getWxUserId();
		TabHaobanStaff staff = staffService.selectByUserIdAndEnterpriseId(userId, wxEnterpriseId);
		if(staff == null){
			return "";
		}

		String suiteid = dto.getSuiteid();		
		String unionIdJson = "";
		if(SELF_APP.equals(suiteid)){
			SecretSettingDTO secretSetting = secretSettingService.getSecretSetting(wxEnterpriseId, SecretTypeEnum.CONTACT_CUSTOMER.getVal());
			if (null == secretSetting) {
				log.info("没有配置secret");
				return "";
			}
			unionIdJson = qywxUserApiService.getCorpSelfExternalUseridInfo(dto.getCorpid(), secretSetting.getSecretVal(), dto.getExternalUserid());
		}else{
			unionIdJson = qywxUserApiService.getExternalUseridInfo(dto.getCorpid(), dto.getSuiteid(), dto.getExternalUserid());
		}
		
		if(StringUtils.isBlank(unionIdJson)){
			log.info("【新增外部联系人回调】unionIdJson=null");
			return "";
		}
		log.info("【新增外部联系人回调】unionIdJson={}",JSON.toJSONString(unionIdJson));
		
		ExternalUserPojo pojo = getExternalUserPojo(unionIdJson,userId,wxEnterpriseId);
		//String unionId = pojo.getUnionId();
		String name = pojo.getName();
		String createTime  = pojo.getAddCreateTime();
		
		String key = "external" + wxEnterpriseId + "_"+ userId + "_" + name + "_" + createTime;
		RedisUtil.lock(key,2l);
		dto.setWxEnterpriseId(wxEnterpriseId);
		
		//dto.setUnionid(unionId);
		dto.setExternalName(name);
		dto.setAddCreateTime(createTime);
		
		MemberUnionidRelatedDTO exsitDTO = memberUnionRelatedService.getByParams(dto.getWxUserId(), wxEnterpriseId,name,createTime);
		String externalUserId = "";
		String selfExternalUserId = "";
		String unionId = "";
		if(SELF_APP.equals(suiteid)){
			unionId = pojo.getUnionId();
			selfExternalUserId = dto.getExternalUserid(); 
		}else{
			externalUserId = dto.getExternalUserid();
		}
		
		
		String uuid = "";
		if(exsitDTO == null){
			dto.setSelfExternalUserid(externalUserId);
			dto.setExternalUserid(selfExternalUserId);
			dto.setUnionid(unionId);
			uuid = memberUnionRelatedService.addMemberUnionidRelated(dto);
		}else{
			//如果是自建更新uuid
			exsitDTO.setSelfExternalUserid(selfExternalUserId);
			exsitDTO.setUnionid(unionId);
			//更新对外联系人id
			exsitDTO.setExternalUserid(externalUserId);
			memberUnionRelatedService.update(exsitDTO);
			uuid = exsitDTO.getMemberUnionidRelatedId();
		}
		
		String staffId = staff.getStaffId();
		
		//新增导购和外部联系人关系
		if(SELF_APP.equals(suiteid)){
			TabHaobanClerkMainStoreRelated r = clerkMainStoreRelatedService.selectByWxEnterpriseIdAndStoreId(staffId,wxEnterpriseId);
			if(r == null){
				log.info("【新增外部联系人】主门店为空");
				return "";
			}
			insertExternalClerkRelatedSelf(pojo, wxEnterpriseId, staffId, uuid, userId, dto.getExternalUserid(),r.getStoreId());
		}else{
			insertExternalClerkRelated(pojo, wxEnterpriseId, staffId, uuid, userId, dto.getExternalUserid());
		}
		return uuid;
	}
	
	
	private void insertExternalClerkRelated(ExternalUserPojo pojo, String wxEnterpriseId, String staffId, String memberUnionidRelatedId,
			String userId, String externalUserid) {
		String unionId = pojo.getUnionId();
		String name = pojo.getName();
		String createTime  = pojo.getAddCreateTime();
		String relaName = name;
		TabHaobanExternalClerkRelated exsitDTO = externalClerkRelatedService.getByParams(userId, wxEnterpriseId,name,createTime);
		if(exsitDTO == null){
			TabHaobanExternalClerkRelated related = new TabHaobanExternalClerkRelated();
			related.setAddCreateTime(createTime);
			related.setExternalName(relaName);
			related.setStaffId(staffId);
			related.setMemberUnionidRelatedId(memberUnionidRelatedId);
			related.setUnionid(unionId);
			related.setWxEnterpriseId(wxEnterpriseId);
			related.setWxUserId(userId);
			externalClerkRelatedService.insert(related);
		}else{
			exsitDTO.setExternalUserId(externalUserid);
			externalClerkRelatedService.update(exsitDTO);
		}
	}
	private void insertExternalClerkRelatedSelf(ExternalUserPojo pojo,String wxEnterpriseId,String staffId,String memberUnionidRelatedId,String userId,String externalUserId,String storeId){
		MemberDTO member = null;
		StoreDTO mainStore = null;
		mainStore = storeService.getStore(storeId);
		if(mainStore == null){
			log.info("【新增外部联系人】门店为空");
			return;
		}
		
		
		StaffClerkRelationDTO staffClerkRelationDTO = staffClerkRelationService.getOneBindByStoreId(staffId,storeId);
		if(staffClerkRelationDTO == null){
			log.info("【新增外币联系人】导购和clerk关联为空");
			return;
		}
		
		String unionId = pojo.getUnionId();
		String name = pojo.getName();
		String createTime  = pojo.getAddCreateTime();
		String avatar = pojo.getAvatar();
		String relaName = name;
		String clerkCode = staffClerkRelationDTO.getClerkCode();
		ClerkDTO clerk = clerkService.getClerkByClerkCode(mainStore.getEnterpriseId(), clerkCode);
		log.info("【新增外部联系人】clerkCode={},unionid:{}",clerkCode,unionId);
		if(clerk != null && StringUtils.isNotBlank(clerk.getQrcodeParam())&&StringUtils.isNotBlank(unionId)){
			log.info("【新增外部联系人会员】enterpriseId={},unionId={},name={},avatar={},QrcodeParam={}",mainStore.getEnterpriseId(),unionId,name,avatar,clerk.getQrcodeParam());
			 member = memberOpenCardBusinessService.getMemberByQywxChannelParam(mainStore.getEnterpriseId(),unionId,"",relaName,avatar,clerk.getQrcodeParam());
		}
		log.info("【新增外部联系人】member={},clerk={}",JSON.toJSONString(member),JSON.toJSONString(clerk));
		TabHaobanExternalClerkRelated exsitDTO = externalClerkRelatedService.getByParams(userId, wxEnterpriseId,name,createTime);
		if(exsitDTO == null){
			TabHaobanExternalClerkRelated related = new TabHaobanExternalClerkRelated();
			related.setAddCreateTime(createTime);
			related.setClerkId(staffClerkRelationDTO.getClerkId());
			related.setEnterpriseId(staffClerkRelationDTO.getEnterpriseId());
			related.setExternalName(relaName);
			related.setExternalUserId(externalUserId);
			related.setStaffId(staffId);
			related.setMemberUnionidRelatedId(memberUnionidRelatedId);
			related.setStoreId(storeId);
			related.setUnionid(unionId);
			related.setWxEnterpriseId(wxEnterpriseId);
			related.setWxUserId(userId);
			if(member != null){
				related.setMemberId(member.getMemberId());
			}
			externalClerkRelatedService.insert(related);

		}else{
			if(member != null){
				exsitDTO.setMemberId(member.getMemberId());
			}
			exsitDTO.setUnionid(unionId);
			exsitDTO.setStoreId(storeId);
			exsitDTO.setEnterpriseId(staffClerkRelationDTO.getEnterpriseId());
			exsitDTO.setClerkId(staffClerkRelationDTO.getClerkId());
			externalClerkRelatedService.update(exsitDTO);
		}
	}
	
	private ExternalUserPojo getExternalUserPojo(String unionIdJson,String userId1,String wxEnterpriseId) {
		ExternalUserPojo pojo = new ExternalUserPojo();
		String unionId = "";
		String follow_user = "";
		String createTime  = "";
		String userId = "";
		String avatar = "";
		String relaName = "";
		if(StringUtils.isNotBlank(unionIdJson)){
			JSONObject jo = JSON.parseObject(unionIdJson);
			String external_contact  = jo.getString("external_contact");
			if(StringUtils.isNotBlank(external_contact)){
				JSONObject jt = JSON.parseObject(external_contact);
				unionId = jt.getString("unionid");
				relaName = EmojiFilterUtil.filterEmojiLast(jt.getString("name"), true);
				avatar = jt.getString("avatar");
			}
			
			follow_user = jo.getString("follow_user");
			if(StringUtils.isNotBlank(follow_user)){
				JSONArray j = JSON.parseArray(follow_user);
				for (Object object : j) {
					String followJson = JSON.toJSONString(object);
					JSONObject follow = JSON.parseObject(followJson);
					userId = follow.getString("userid");
					if(userId.equals(userId1)){
						createTime = follow.getString("createtime");
					}
				}
			}
		}
		pojo.setAddCreateTime(createTime);
		pojo.setAvatar(avatar);
		pojo.setName(relaName);
		pojo.setUnionId(unionId);
		pojo.setWxEnterpriseId(wxEnterpriseId);
		return pojo;
	}
	@Override
	public String add(String wxEnterpriseId,String selfExternalUserId,String userId,String storeId) {
		WxEnterpriseDTO wxEnterprise = wxEnterpriseService.selectById(wxEnterpriseId);
		if(wxEnterprise == null){
			return "";
		}
		
		TabHaobanStaff staff = staffService.selectByUserIdAndEnterpriseId(userId, wxEnterpriseId);
		if(staff == null){
			return "";
		}
		
		SecretSettingDTO secretSetting = secretSettingService.getSecretSetting(wxEnterpriseId, SecretTypeEnum.CONTACT_CUSTOMER.getVal());
		if (null == secretSetting) {
			log.info("没有配置secret");
			return "";
		}
		String unionIdJson = qywxUserApiService.getCorpSelfExternalUseridInfo(wxEnterprise.getCorpid(), secretSetting.getSecretVal(), selfExternalUserId);
		
		ExternalUserPojo pojo = getExternalUserPojo(unionIdJson,userId,wxEnterpriseId);
		String unionId = pojo.getUnionId();
		String name = pojo.getName();
		String createTime  = pojo.getAddCreateTime();
		
		MemberUnionidRelatedDTO dto = new MemberUnionidRelatedDTO();
		String externalUserId = getExternalUserId(wxEnterprise, userId, createTime, name);
		
		dto.setExternalUserid(externalUserId);
		dto.setWxEnterpriseId(wxEnterpriseId);
		dto.setUnionid(unionId);
		
		dto.setExternalName(name);
		dto.setAddCreateTime(createTime);
		dto.setWxUserId(userId);
		
		if(StringUtils.isBlank(unionId)){
			return "";
		}
		
		dto.setSuiteid(secretSetting.getSecretVal());
		
		MemberUnionidRelatedDTO exsitDTO = memberUnionRelatedService.getByParams(userId, wxEnterpriseId,name,createTime);
		String uuid = "";
		if(exsitDTO == null){
			dto.setUnionid(unionId);
			//更新对外联系人id
			dto.setSelfExternalUserid(selfExternalUserId);
			uuid = memberUnionRelatedService.addMemberUnionidRelated(dto);
		}else{
			return "";
		}
		
		//新增门店和导购的关联关系
		String staffId = staff.getStaffId();
		insertExternalClerkRelatedSelf(pojo, wxEnterpriseId, staffId, uuid, userId, dto.getExternalUserid(),storeId);
		
		return uuid;
	}
	
	
	private String getExternalUserId(WxEnterpriseDTO wxEnterprise,String userId1,String createTime,String name){
		log.info("新增外部联系人】corpid={},suiteId={},userId1={}",wxEnterprise.getCorpid(),config.getWxSuiteid(),userId1);
		String wxRes = qywxUserApiService.listExternalUserid(wxEnterprise.getCorpid(), config.getWxSuiteid(), userId1);
		String externalUserId = "";
		log.info("【新增外部联系人】wxRes={}",wxRes);
		if(StringUtils.isNotBlank(wxRes)){
			JSONArray jsonArr = JSON.parseArray(wxRes);
			String wxName = "";
			for (Object externalUserid : jsonArr) {
				String uJ = qywxUserApiService.getExternalUseridInfo(wxEnterprise.getCorpid(), config.getWxSuiteid(), externalUserid.toString());
				
				if(StringUtils.isNotBlank(uJ)){
					JSONObject jo = JSON.parseObject(uJ);
					String external_contact  = jo.getString("external_contact");
					String uj_follow_user = jo.getString("follow_user");
					if(StringUtils.isNotBlank(external_contact)){
						JSONObject jt = JSON.parseObject(external_contact);
						externalUserId = jt.getString("external_userid");
						wxName = EmojiFilterUtil.filterEmojiLast(jt.getString("name"), true);
					}
					if(StringUtils.isNotBlank(uj_follow_user)){
						JSONArray j = JSON.parseArray(uj_follow_user);
						String uj_userId = "";
						for (Object object : j) {
							String followJson = JSON.toJSONString(object);
							JSONObject follow = JSON.parseObject(followJson);
							uj_userId = follow.getString("userid");
							log.info("【新增外部联系人】createTime={},name={},followCreateTime={},wxName={}",createTime,name,follow.getString("createtime"),wxName);
							if(uj_userId.equals(userId1) && createTime.equals(follow.getString("createtime")) && name.equals(wxName)){
								break;
							}
						}
					}
				}
			}
		}
		return externalUserId;
	}
	@Override
	public void delMemberUnionidRelated(MemberUnionidRelatedDTO dto) {
		externalClerkRelatedService.delByUserIdAndExternalUserId(dto);
		memberUnionRelatedService.delMemberUnionidRelated(dto);
		
	}

	@Override
	public MemberUnionidRelatedDTO getByMemberId(String staffId, String memberId) {
		TabHaobanStaff staff = staffService.selectById(staffId);
		if(staff == null){
			return null;
		}
		log.info("【查询会员】wxUserId={},unionid={}",staff.getWxUserId(),memberId);
		return memberUnionRelatedService.getByMemberId(staff.getWxUserId(),memberId);
	}
	@Override
	public List<MemberUnionidRelatedDTO> getByWxUserIdAndWxEnterpriseId(String wxUserId, String wxEnterpriseId) {
		List<MemberUnionidRelatedDTO> list = memberUnionRelatedService.getByWxUserIdAndWxEnterpriseId(wxUserId,wxEnterpriseId);
		return list;
	}
	@Override
	public List<MemberUnionidRelatedDTO> listByEnterpriseIdAndDate( String enterpriseId,Date date) {
		List<MemberUnionidRelated> list = memberUnionidRelatedMapper.listByEnterpriseIdAndDate(enterpriseId,date);
		return EntityUtil.changeEntityListByJSON(MemberUnionidRelatedDTO.class,list);
	}
	
	@Override
	public void freshWxFrend(String wxEnterpriseId, String wxUserId,String storeId) {
		log.info("【刷下好友】wxUserId={}",wxUserId);
		WxEnterpriseDTO enterprise = wxEnterpriseService.selectById(wxEnterpriseId);
        SecretSettingDTO secretSetting = secretSettingService.getSecretSetting(wxEnterpriseId, SecretTypeEnum.CONTACT_CUSTOMER.getVal());
        if (null == secretSetting||secretSetting.getCheckFlag()==0) {
            log.info("没有配置客户联系secret:{}",wxEnterpriseId);
            return;
        }
        String res = qywxUserApiService.listSelfExternalUserid(enterprise.getCorpid(), secretSetting.getSecretVal(), wxUserId);
		log.info("【刷下好友】res={}",res);
		if(StringUtils.isBlank(res)){
			return;
		}
		JSONArray jsonArr = JSON.parseArray(res);
		if(jsonArr.size() == 0) {
			return;
		}
		List<MemberUnionidRelatedDTO> list = this.getByWxUserIdAndWxEnterpriseId(wxUserId, wxEnterpriseId);
		List<String> externalUserIdList = list.stream().map(student->student.getSelfExternalUserid())
				   .collect(Collectors.toList());
		for (Object object : jsonArr) {
			if(externalUserIdList.contains(object.toString())){
				continue;
			}else{
				//String string = qywxUserApiService.getCorpSelfExternalUseridInfo(enterprise.getCorpid(), enterprise.getWxSecretKey(), object.toString());
				this.add(wxEnterpriseId, object.toString(), wxUserId,storeId);
			}
		}
		
	}
	
	@Override
	public void mqFreshWxFrend(String res){
		JSONObject json = JSON.parseObject(res);
		String wxEnterpriseId = json.getString("wxEnterpriseId");
		String wxUserId = json.getString("wxUserId");
		String storeId = json.getString("storeId");
		log.info("【刷下微信好友】wxEnterpriseId={}.wxUserId={},storeId={}",wxEnterpriseId,wxUserId,storeId);
		if(StringUtils.isAnyBlank(wxEnterpriseId,wxUserId,storeId)){
			return ;
		}
		freshWxFrend(wxEnterpriseId, wxUserId, storeId);
	}

	@Override
	public void cleanByCid(String cid) {
		if (StringUtils.isNotBlank(cid)) {
			TabHaobanWxEnterprise wxEnterprise = wxEnterpriseService.getEnterpriseBycorpId(cid);
			if (null != wxEnterprise) {
				memberUnionRelatedService.clean(wxEnterprise.getWxEnterpriseId());
			}
		}else {
			memberUnionRelatedService.clean(null);
		}
	}
	@Override
	public Page<MemberUnionidRelatedDTO> pageMemberUnionByParams(List<String> userIdList, List<String> sendMemberIds,
			String enterpriseId, BasePageInfo pageInfo) {
		PageHelper.startPage(pageInfo.getPageNum(), pageInfo.getPageSize());
		return  PageUtil.changePageHelperToCurrentPage(memberUnionRelatedService.pageMemberUnionByParams(userIdList,sendMemberIds,enterpriseId),MemberUnionidRelatedDTO.class);
	}
	
	@Override
	public String sendMessage(String wxEnterpriseId,String userId,List<String> extendUserList,String materialId){
		WxEnterpriseDTO enterprise = wxEnterpriseService.selectById(wxEnterpriseId);
		MaterialDTO material = materialApiService.selectMaterialById(materialId);
		if(material == null){
			return "";
		}
		JSONResponse jp = null;
		if(material.getMaterialType() == 2 || material.getMaterialType() == 4 || material.getMaterialType() == 5){
			Date wxLastTime = material.getWxLastUploadTime();
			String maerialId = material.getMediaId();
			if(DateUtil.addDay(wxLastTime, 3).getTime() < System.currentTimeMillis()){
				maerialId = materialApiService.reUpdalodMetail(materialId);
			}
			QywxImageExternalMessageDTO dto = new QywxImageExternalMessageDTO();
			dto.setMediaId(maerialId);
			dto.setChatType("single");
			dto.setExternalUserid(extendUserList);
			dto.setSenderUserId(userId);
			log.info("【发送消息】dto = {}",JSON.toJSONString(dto));
			jp = qywxSuiteApiService.sendExternalMessage(enterprise.getCorpid(), config.getWxSuiteid(), dto);
		}else if(material.getMaterialType() == 1){
			QywxTextExternalMessageDTO dto = new QywxTextExternalMessageDTO();
			dto.setChatType("single");
			dto.setExternalUserid(extendUserList);
			dto.setSenderUserId(userId);
			dto.setText(material.getMaterialContent());
			log.info("【发送消息】dto = {}",JSON.toJSONString(dto));
			jp = qywxSuiteApiService.sendExternalMessage(enterprise.getCorpid(), config.getWxSuiteid(), dto);
		}else if(material.getMaterialType() == 3){
			QywxIinkExternalMessageDTO dto = new QywxIinkExternalMessageDTO();
			dto.setChatType("single");
			dto.setExternalUserid(extendUserList);
			dto.setSenderUserId(userId);
			dto.setDesc(material.getMaterialDesc());
			dto.setPicurl(material.getWxImgUrl());
			dto.setTitle(material.getMaterialTitle());
			dto.setUrl(material.getLink());
			log.info("【发送消息】dto = {}",JSON.toJSONString(dto));
			jp = qywxSuiteApiService.sendExternalMessage(enterprise.getCorpid(), config.getWxSuiteid(), dto);
		}
		log.info("【发送消息】jp = {}",JSON.toJSONString(jp));
		Map<String,Object> returnMap = jp.getReturnMap();
		return returnMap.get("msgid") == null?"":returnMap.get("msgid").toString();
	}
	@Override
	public JSONResponse getMessageStatus(String wxEnterpriseId, String wxMessageId) {
		WxEnterpriseDTO enterprise = wxEnterpriseService.selectById(wxEnterpriseId);
		if(enterprise == null){
			return null;
		}
		JSONResponse jp = qywxSuiteApiService.resultExternalMessage(enterprise.getCorpid(), config.getWxSuiteid(), wxMessageId);
		return jp;
	}
	@Override
	public List<MemberUnionidRelatedDTO> getByWxUserIdListAndWxEnterpriseId(List<String> userIdList,
			String wxEnterpriseId) {
		return EntityUtil.changeEntityListByJSON(MemberUnionidRelatedDTO.class, memberUnionidRelatedMapper.getByWxUserIdListAndWxEnterpriseId(userIdList,wxEnterpriseId));
	}
}
